import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.imageio.*;
import java.net.*;
import java.util.*;

public class schema extends JApplet
{
    private JTree arb;
    private int picHeight;

    public void init()
    {
        try { UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel"); }
        catch (Exception e1)
              { 
                  System.err.println ("Nu am putut incarca template-ul specific Windows, incerc sa incarc template-ul corespunzator sistemului de operare curent");
                  try { UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); }
                  catch (Exception e2)
                        { 
                            System.err.println ("Nu am putut incarca template-ul specific sistemului de operare curent, incerc sa incarc template-ul specific Java");
                            try { UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName()); }
                            catch (Exception e3)
                                  { System.err.println ("Nu am putut incarca template-ul specific Java. Aceasta era ultima varianta; probabil ca versiunea Java instalata este corupta."); }
                        }
              }
                          
        
        
        if (getParameter ("picHeight") != null)
           {
               picHeight = Integer.parseInt (getParameter ("picHeight"));
               if (picHeight <= 0)
                  picHeight = 1;
           }
        else
           picHeight = 30;
        
        creeazaArbore (); 
        if (picHeight > 30)
           { arb.setRowHeight (picHeight); }
        else
           { arb.setRowHeight (30); }
        arb.getSelectionModel ().setSelectionMode (TreeSelectionModel.SINGLE_TREE_SELECTION);
        
        try { SwingUtilities.invokeAndWait (new Runnable() 
              {
                  public void run() 
                  { initGUI(); }
              });
            } 
        catch (Exception e4) 
              { System.err.println("Interfata grafica nu a putut fi initializata"); }
    }

    private void initGUI ()
    {
        Image angajatImg = citesteImagine (getParameter ("pozaAngajat"));
        if (angajatImg == null)
           { angajatImg = new BufferedImage (1, 1, BufferedImage.TYPE_BYTE_BINARY); }
        arb.setCellRenderer (new MyRenderer (new ImageIcon (angajatImg)));
 
        JScrollPane foaie = new JScrollPane (arb);
        JLabel titlu = new JLabel ("<html><b style=\"font-size:18px; font-weight: bold\">Schema organizatiei</b></html>",SwingConstants.CENTER);
        Container cp = this.getContentPane ();
        
        titlu.setOpaque (true);
        titlu.setBackground (Color.white);
        cp.setLayout (new BorderLayout ());
        cp.add (titlu,BorderLayout.NORTH);
        cp.add (foaie,BorderLayout.CENTER);
    }
    
    private void creeazaArbore ()
    {
        int i=1, n=0, id, sefDirect;
        String nume, functie, imagine;
        DefaultMutableTreeNode vf = null, fiu, tata;
        HashMap <Integer,DefaultMutableTreeNode> hm = new HashMap <Integer,DefaultMutableTreeNode> ();
        
        if (getParameter ("nrAng") != null)
           { try { n = Integer.parseInt (getParameter ("nrAng")); }
             catch (Exception e)
                   { n=0; }
           }
        
        for (i=1; i<=n; i++) 
            {
                nume = getParameter ("ang"+i+"nume");
                functie = getParameter ("ang"+i+"functie");
                imagine = getParameter ("ang"+i+"imagine");
                id = new Integer (getParameter ("ang"+i+"id"));
                sefDirect = new Integer (getParameter ("ang"+i+"sefDirect"));
                
                if (hm.containsKey (id))
                   { 
                       fiu = hm.get (id);
                       ((Angajat) fiu.getUserObject ()).setAngajat (nume,functie,imagine);
                   }
                else
                   {
                       fiu = new DefaultMutableTreeNode (new Angajat (nume,functie,imagine));
                       hm.put (id, fiu);
                   }
                
                if (hm.containsKey (sefDirect))
                   { tata = hm.get (sefDirect); }
                else
                   { 
                       tata = new DefaultMutableTreeNode (new Angajat ());
                       hm.put (sefDirect, tata); 
                   }
                tata.add (fiu);
                
                if (i == 1)
                   vf = fiu;
            }
            
        if (vf != null)
           arb = new JTree (vf);
        else
           arb = new JTree ();
    }
    
    private Image citesteImagine (String imagine)
    {
        BufferedImage img = null;
        try { 
                img = ImageIO.read (new URL (getCodeBase (), "poze/" + imagine)); 
                if (img.getHeight () > picHeight)
                   { return img.getScaledInstance (-1, picHeight, Image.SCALE_FAST); }
            }
        catch (Exception e)
              { 
                  if (imagine != null && !imagine.trim ().equals (""))
                     { System.err.println("Nu am putut citi fisierul-imagine poze/" + imagine); }
              }
        return img;
    }

    //Contine informatii legate de acest JApplet.
    public String getAppletInfo()
    {
        return "Title: Schema organizatiei unei companii  \nAuthor: Tene Matei  \nAcest applet foloseste Java Runtime Environment versiunea 6 sau mai noua. ";
    }


    //Contine informatii legate parametrii pe care trebuie sa-i primeasca acest JApplet
    public String[][] getParameterInfo()
    {
        String paramInfo[][] = {
                 {"picHeight", "int: 0-maxint", "inaltimea la care vor fi afisate pozele angajatilor"},
                 {"pozaAngajat", "String: fisier imagine", "Fisisrul ce contine imaginea ce va fi afisata in cazul in care unui angajat nu-i este asociata o imagine proprie"},
                 {"nrAng",   "int: 1-maxint", "numarul de angajati ai companiei (ce vor fi afisati). In continuare vor fi trimise ca parametri informatiile celor nrAng angajati. In numele acestor parametri X va fi inlocuit cu nr de ordine al angajatului (incepand cu 1)"},
                 {"angXnume",   "String", "numele angajatului X"},
                 {"angXfunctie",   "String", "functia angajatului X"},
                 {"angXimagine",   "String: fisier imagine", "imaginea asociata angajatului X"},
                 {"angXid",   "int", "id-ul asociat angajatului X in arborele organizatiei"},
                 {"angXsefDirect",   "int", "id-ul asociat sefului direct al angajatului XX in arborele organizatiei"}
        };
        return paramInfo;
    }
    
    private class Angajat 
    { 
        public String nume, functie;
        public Image imagine;
        
        public Angajat ()
        { this.nume = "";
          this.functie = "";
          this.imagine = null;
        }
        
        public Angajat (String nume, String functie, String imagine)
        { 
            this.nume = nume;
            this.functie = functie;
            this.imagine = citesteImagine (imagine);
        }
        
        public void setAngajat (String nume, String functie, String imagine)
        { 
            this.nume = nume;
            this.functie = functie;
            this.imagine = citesteImagine (imagine);
        }
        
        public String toString ()
        {
            return "<html>" + nume + "<br><b>" + functie+ "</b></html>";
        }
    }
    
    private class MyRenderer extends DefaultTreeCellRenderer 
    {
        private ImageIcon angajatIcon;

        public MyRenderer (ImageIcon angajatIcon) 
        { this.angajatIcon = angajatIcon; }

        public Component getTreeCellRendererComponent (JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) 
        {
            super.getTreeCellRendererComponent (tree, value, sel, expanded, leaf, row, hasFocus);
            
            DefaultMutableTreeNode nod = (DefaultMutableTreeNode) value;
            Angajat ang = (Angajat) (nod.getUserObject());
            
            if (ang.imagine != null)
               { setIcon (new ImageIcon (ang.imagine)); }
            else
               { setIcon (angajatIcon); }

            return this;
        }
    }
}
